
console.log("我是exe本地js");
const { ipcRenderer } = require('electron');
const Webview = require("./webview");
const { appPath } = require('electron').remote.require("./main");

const rpcCall = (moduleName, methodName, params) => {
  return new Promise((resolve, reject) => {
    Webview.rpcCall(ipcRenderer, moduleName, methodName, params, ([err, res]) => {
      if (err) {
        reject(err);
      } else {
        resolve(res);
      }
    });
  });
}



window.pi_exe_sdk = {
  rpcCall,
  appPath,
};


const getBootFiles = (jsInterceptID, paths) => {
  return rpcCall(undefined, "getBootFiles", [jsInterceptID, paths]);
}

const getAppVersion = (jsInterceptID) => {
  return rpcCall(undefined, "getAppVersion", [jsInterceptID]);
}

const saveFile = (path, content, jsInterceptID) => {
  return rpcCall(undefined, "saveFile", [path, content, jsInterceptID]);
}

const restartApp = (restartPath) => {
  return rpcCall(undefined, "restartApp", [restartPath]);
}

window.JSIntercept = {
  getBootFiles,
  getAppVersion,
  saveFile,
  restartApp
};
