/**
 * 模拟浏览器环境入口
 * window
 * websock
 * indexdb
 * http
 */

const WebSocket = require('ws');
const PiV8Db = require("./piV8Db").PiV8Db;
const Rpc = require("../electron/rpc");
const fetch = require('node-fetch');


const initBrowserEnv = (appPath) => {
    global.window = global;
    global.self = global;
    window.fetch = fetch;
    window.navigator = {
        platform: "Win32",
        language: "zh-CN",
        userAgent: "Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/78.0.3904.130 JSVM_Electron/7.1.7 Safari/537.36"
    };
    window.crypto = {
        getRandomValues: (cache) => {
            for (let i = 0; i < cache.byteLength; i++) {
                cache[i] = Math.floor(Math.random() * 0xffffffff);
            }
        }
    };
    window.WebSocket = WebSocket;
    window.JSVM = {
        store: new PiV8Db(appPath),
        rpcCall: Rpc.rpcCall
    };
}

exports.initBrowserEnv = initBrowserEnv;