const main = require("../main");
const JSIntercept = require("./JSIntercept");


const parserError = (err) => {
    if (err instanceof Error) return err.message;
    return JSON.stringify(err);
}

const getBootFiles = (jsInterceptID, paths, cb) => {
    cb && cb([undefined, main.executeJs(JSIntercept.getBootFiles(main.userDataPath, jsInterceptID, paths))]);
}

const getAppVersion = (jsInterceptID, cb) => {
    cb && cb([undefined, main.executeJs(JSIntercept.getAppVersion(jsInterceptID))]);
}

const saveFile = (path, content, jsInterceptID, cb) => {
    cb && cb([undefined, main.executeJs(JSIntercept.saveFile(main.userDataPath, path, content, jsInterceptID))]);
}

const restartApp = (restartPath, cb) => {
    cb && cb([undefined, main.restartApp(restartPath)]);
}

const getLocalGameConfig = (cb) => {
    main.getLocalGameConfig().then(r => {
        cb([undefined, r]);
    }).catch(err => {
        cb([parserError(err)]);
    });;
}

const maximize = (cb) => {
    cb && cb([undefined, main.maximize()]);
}

const isMaximized = (cb) => {
    cb && cb([undefined, main.isMaximized()]);
}

const restore = (cb) => {
    cb && cb([undefined, main.restore()]);
}

const close = (cb) => {
    main.close(); // 这里直接关闭 
    // cb && cb([undefined, main.close()]);
}

const reload = (cb) => {
    cb && cb([undefined, main.reload()]);
}
const minimize = (cb) => {
    cb && cb([undefined, main.minimize()]);
}

global.pi_remote = {
    getBootFiles,
    getAppVersion,
    saveFile,
    restartApp,
    getLocalGameConfig,
    maximize,
    isMaximized,
    restore,
    close,
    reload,
    minimize
};